package impeer;

import java.net.*;
import java.io.*;
import java.util.*;

public class FileTransfer extends Thread {
	private Socket socket;
	private BufferedInputStream in;
	private BufferedOutputStream out;
	private boolean succeed;
	
	public FileTransfer(String fullPath, InetAddress desAddress, int port) {
		succeed = true;
		try {
			out = new BufferedOutputStream(new FileOutputStream(fullPath));
			socket = new Socket(desAddress, port);
			in = new BufferedInputStream(socket.getInputStream());
		}

		catch (IOException e) {
			succeed = false;
		}
	}
        public FileTransfer(File fullPath, InetAddress desAddress, int port) {
		succeed = true;
		try {
			out = new BufferedOutputStream(new FileOutputStream(fullPath));
			socket = new Socket(desAddress, port);
			in = new BufferedInputStream(socket.getInputStream());
		}

		catch (IOException e) {
			succeed = false;
		}
	}
        
	public FileTransfer(String fullPath, int port) {
		succeed = true;
		try {
			in = new BufferedInputStream(new FileInputStream(fullPath));
			socket = new ServerSocket(port).accept();
			out = new BufferedOutputStream(socket.getOutputStream());
		}

		catch (IOException e) {
			succeed = false;
		}
	}
        
        public FileTransfer(File fullPath, int port) {
		succeed = true;
		try {
			in = new BufferedInputStream(new FileInputStream(fullPath));
			socket = new ServerSocket(port).accept();
			out = new BufferedOutputStream(socket.getOutputStream());
		}

		catch (IOException e) {
			succeed = false;
		}
	}

	public void suicide() {
            try {
                in.close();
                out.close();
                socket.close();
            }
            catch (Exception e) {
                
            }
            succeed = false;
        }
        
        public void run() {
		try {
			if (succeed) {
				int tmp;
				while ((tmp = in.read()) != -1) {
					out.write(tmp);
					//System.out.println(tmp);
				} 
				in.close();
				out.close();
				socket.close();
			}
			else {
				System.err.println("Bad use of this tools");
			}
		}
		catch (Exception e) {
			System.err.println("Some error occured when transfering the file!\n" + e);
		}
	}

	public static void main(String [] args) {
		switch (args.length) {
			case 1 :new FileTransfer(args[0], 3962).start();
				break;
			case 2 :try {
					new FileTransfer(args[0],InetAddress.getByName(args[1]),3962).start();
				}
				catch (UnknownHostException e) {
					System.err.println(e);
				}
				break;
			default:System.out.println("Illegality use this tools!");
		}
	}
}
