/*
 * GetMessage.java
 *
 * Created on 2007年7月5日, 下午2:19
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package impeer;

import java.net.*;
import java.io.*;
import java.util.*;

/**
 *
 * @author amankwah
 */
public class GetMessage extends Thread {
    
    private DatagramSocket listenSocket;
    private Message msg;
    private MainList list;
    
    /** Creates a new instance of GetMessage */
    public GetMessage(MainList ml) {
        try {
            listenSocket = new DatagramSocket(3962);
        }
        catch (Exception e) {
            System.err.println(e);
            System.exit(-1);
        }
        list = ml;
    }
    
    public static InetAddress getLocalIp() {
		try {
			Enumeration<NetworkInterface> interfaces = NetworkInterface.getNetworkInterfaces();
			while (interfaces.hasMoreElements()) {
				NetworkInterface interfaceN = (NetworkInterface)interfaces.nextElement();
				Enumeration<InetAddress> ienum = interfaceN.getInetAddresses();
				while (ienum.hasMoreElements()) {
					InetAddress ia = ienum.nextElement();
					if(ia.getHostAddress().toString().startsWith("127")) {
						continue;
					}
					else {
						return ia;
					}
				}
			}
		}
		catch (Exception e) {
			System.err.println(e);
			e.printStackTrace();
		}
		
		return null;
    }
    
    public void parse() {
        int command = 1000;
        InetAddress srcAddr = null;
        String [] array = {"MESG","ALLO","ACKN","FILE"};
        for(int i = 0; i < array.length; i++) {
            if (array[i].equalsIgnoreCase(msg.getCmd())) {
                command = i;
            }
        }
        
        try {
            srcAddr = InetAddress.getByName(msg.getIp());
        }
        catch (UnknownHostException e) {
            return;
        }
        
        if ((command == 1) && (msg.getIp().equals(GetMessage.getLocalIp().getHostAddress()))) {
            command = 2;
        }
         
        switch (command) {
            case 0 : new MessageInWindow(srcAddr,msg.getArg()).setVisible(true);
                     System.out.println(msg.getArg());
                     break;
            case 1 : byte [] data = "ACKN".concat(" ").getBytes();
                     try {
                         DatagramSocket tmpSocket = new DatagramSocket();
                         tmpSocket.send(new DatagramPacket(data,data.length,srcAddr,3962));
                         tmpSocket.close();
                     }
                     catch (Exception e) {
                         
                     }
            case 2 : list.addPeer(srcAddr);
                     break;
            case 3 : System.out.println("I'm transfering file!");
                     new ReceivFile(srcAddr, msg.getArg()).setVisible(true);
                     break;
            default:
        }
    }
    
    
    
    public void run(){
        byte [] buffer = new byte[8192];
        DatagramPacket data = new DatagramPacket(buffer,1024);
        while (true) {
            try {
                listenSocket.receive(data);
            }
            catch (IOException e) {
                continue;
            }
            //System.out.println("receive package length:"+data.getLength());
            //System.out.println("buffer length:"+new String(buffer).length());
            msg = new Message(data);
            //System.out.println(msg.getIp());
            System.out.println(msg.getCmd() +" " + msg.getArg() + " from:" + msg.getIp());
            parse();
            msg = null;
        }
    }
}
